/**
 * hpgv_gl.h
 *
 * Copyright (c) 2008 Hongfeng Yu
 *
 * Contact:
 * Hongfeng Yu
 * hfstudio@gmail.com
 * 
 * 
 * All rights reserved.  May not be used, modified, or copied 
 * without permission.
 *
 */

#ifndef HPGV_GL_H
#define HPGV_GL_H

#ifdef __cplusplus
extern "C" {
#endif
    
#if defined(__gl_h_) || defined(__GL_H__)  
    #define HPGV_RGB GL_RGB
    #define HPGV_RGBA GL_RGBA
    #define HPGV_BYTE GL_BYTE
    #define HPGV_UNSIGNED_BYTE GL_UNSIGNED_BYTE
    #define HPGV_SHORT GL_SHORT
    #define HPGV_UNSIGNED_SHORT GL_UNSIGNED_SHORT
    #define HPGV_INT GL_INT
    #define HPGV_UNSIGNED_INT GL_UNSIGNED_INT
    #define HPGV_FLOAT GL_FLOAT
    #define HPGV_DOUBLE GL_DOUBLE
    #define HPGV_LIGHTING GL_LIGHTING
#else        
    #define HPGV_RGB 0x1907
    #define HPGV_RGBA 0x1908                         
    #define HPGV_BYTE 0x1400
    #define HPGV_UNSIGNED_BYTE 0x1401
    #define HPGV_SHORT 0x1402
    #define HPGV_UNSIGNED_SHORT 0x1403
    #define HPGV_INT 0x1404
    #define HPGV_UNSIGNED_INT 0x1405
    #define HPGV_FLOAT 0x1406
    #define HPGV_DOUBLE 0x140A  
    #define HPGV_LIGHTING 0x0B50  
#endif
        
    
int 
hpgv_typesize(int type);

int
hpgv_formatsize(int format);

int  
hpgv_vis_saveppm(int width, int height, int format, int type, 
                 const void *pixels, char *filename);

    
#ifdef __cplusplus
}
#endif

#endif
