/**
 * hpgv_composite.h
 *
 * Copyright (c) 2008 Hongfeng Yu
 *
 * Contact:
 * Hongfeng Yu
 * hfstudio@gmail.com
 * 
 * 
 * All rights reserved.  May not be used, modified, or copied 
 * without permission.
 *
 */


#ifndef HPGV_COMPOSITE_H
#define HPGV_COMPOSITE_H

#ifdef __cplusplus
extern "C" {
#endif

#include "hpgv_gl.h"
#include "hpgv_util.h"
#include "hpgv_utilmath.h"


/**
 * hpgv_composite
 *
 */
int  
hpgv_composite(
               /* dimnsions of pixel rectangle */
               int width,                   
               int height,              
               
                /* format of pixels data. Must be one 
                   of GL_RGBA, GL_RGB, HPGV_RGBA, HPGV_RGB */
               int format,                  
               
               /* data type of pixel data. Must be one
                  of GL_UNSIGNED_BYTE, GL_FLOAT, HPGV_UNSIGNED_BYTE, 
                  or HPGV_FLOAT*/
               int type,                    
               
               /* address of partial iamge */
               void *partialpixels,         
               
                /* address of final image (significant only at root) */
               void *finalpixels,           
                
               /* visibility order */
               float depth,                 
               
               /* rank of root process */
               int root,                    
               
               /* communicator */
               MPI_Comm comm
              );

         
         
/**
 * hpgv_composite_init
 *
 */
int
hpgv_composite_init(MPI_Comm mpicomm);


/**
 * hpgv_composite_finalize
 *
 */
int
hpgv_composite_finalize(MPI_Comm mpicomm);


/**
 * hpgv_composite_valid
 *
 */
int
hpgv_composite_valid();

#ifdef __cplusplus
}
#endif

#endif

