/**
 * hpgv_util.h
 *
 * Copyright (c) 2008 Hongfeng Yu
 *
 * Contact:
 * Hongfeng Yu
 * hfstudio@gmail.com
 * 
 * 
 * All rights reserved.  May not be used, modified, or copied 
 * without permission.
 *
 */

#ifndef HPGV_UTIL_H
#define HPGV_UTIL_H

#ifdef __cplusplus
extern "C" {
#endif
    
#include "hpgv_error.h"
#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdarg.h>
#include <string.h>

#if !defined(MAXLINE)
    #define MAXLINE 4096      /* max line length */
#endif

#define HPGV_ERR_MSG(id, msg) {\
    fprintf(stderr, "Proc %d <%s:%s:%d> : %s \n", \
            (id), __FILE__, __func__, __LINE__, (msg));\
}
                 
#define HPGV_ABORT(id, msg, errno) {\
    HPGV_ERR_MSG(id, msg); \
    MPI_Abort(MPI_COMM_WORLD, errno);\
    exit(errno);\
}

#define HPGV_ASSERT(id, condition, msg, errno) {\
    if (!(condition)) {\
        HPGV_ABORT(id, msg, errno);\
    }\
}

void 
hpgv_msg(int id, int root, const char *fmt, ...);

#ifdef __cplusplus
}
#endif

    
#endif
